%% Chapter 6: Fixed Income
% Example 5: Term Structure Analysis and Interest-Rate Swaps
%%% This example illustrates some of the term-structure analysis functions found in Financial Toolbox software
%% Step 1
Settle   = datenum('15-Jan-2017');
BondData = {'15-Jul-2017'  0.06000   99.93
            '15-Jan-2018'  0.06125   99.72
            '15-Jul-2018'  0.06375   99.70
            '15-Jan-2019'  0.06500   99.40
            '15-Jul-2019'  0.06875   99.73
            '15-Jan-2020'  0.07000   99.42
            '15-Jul-2020'  0.07250   99.32
            '15-Jan-2021'  0.07375   98.45
            '15-Jul-2021'  0.07500   97.71
            '15-Jan-2022'  0.08000   98.15};
Maturity= datenum(char(BondData{:,1}));
CouponRate= [BondData{:,2}]';
Prices = [BondData{:,3}]';
Period= 2;
%% Step 2
ZeroRates = zbtprice([Maturity CouponRate], Prices, Settle,2);
%% Step 3
ForwardRates = zero2fwd(ZeroRates, Maturity, Settle);
%% Step 4
DiscountFactors = zero2disc(ZeroRates, Maturity, Settle);
%% Step 5
PresentValue=sum((ForwardRates/Period) .* DiscountFactors)
%% Step 6
SwapFixedRate = Period * PresentValue / sum(DiscountFactors);
[ZeroRates  ForwardRates]
SwapFixedRate
