%% Chapter 7: Options
%Example 3: Plotting Sensitivities of a Portfolio of Options
%%
Range = 20:90;
PLen = length(Range);
ExPrice = [75 70 50 55 75 50 40 75 60 35]; 
Rate = 0.1*ones(10,1);
Time = [36 36 36 27 18 18 18 9 9 9];
Sigma = 0.35*ones(10,1);
NumOpt = 1000*[4 8 3 5 5.5 2 4.8 3 4.8 2.5];
ZVal = zeros(36, PLen);
Color = zeros(36, PLen);
for i = 1:10
    Pad = ones(Time(i),PLen);
    NewR = repmat(Range,Time(i),1);
    %NewR = Range(ones(Time(i),1),:);
    T = (1:Time(i))';
    NewT=repmat(T,1,PLen);
    %NewT = T(:,ones(PLen,1));
    ZVal(36-Time(i)+1:36,:) = ZVal(36-Time(i)+1:36,:) + NumOpt(i) * blsgamma(NewR, ExPrice(i)*Pad, Rate(i)*Pad, NewT/36, Sigma(i)*Pad);
    Color(36-Time(i)+1:36,:) = Color(36-Time(i)+1:36,:)+ NumOpt(i) * blsdelta(NewR, ExPrice(i)*Pad, Rate(i)*Pad, NewT/36, Sigma(i)*Pad);
end
figure;
mesh(Range, 1:36, ZVal, Color);
view(60,60);
set(gca, 'xdir','reverse');
axis([20 90 0 36 -inf inf]);
title('Call Option Portfolio Sensitivity');
xlabel('Stock Price ($)');
ylabel('Time (months)');
zlabel('Gamma');
set(gca, 'box', 'on');
colorbar('horiz');



